#!/bin/sh

if [ -x "/usr/bin/perl" ]; then
        PERL=/usr/bin/perl
elif [ -x "/opt/VRTSperl/bin/perl" ]; then
        PERL=/opt/VRTSperl/bin/perl
else
        PERL=`/usr/bin/which perl | /usr/bin/grep -v '^no'`
        if [ -z "$PERL" ]; then
                echo "Cannot find a version of perl to execute script"
                exit 1
        fi
fi
eval 'exec $PERL -x -S $0 ${1+"$@"}'
        if 0;
#!perl

$DEFAULT_SYM_HOME = "/usr/symcli";

if($#ARGV < 0)
{
	exit 1;
}
elsif($ARGV[0] =~ /^-devices/)
{
	my $symhome, $symdg;
	@args = split(/:/, $ARGV[0]);
	shift(@args);
	if($args[0] eq "")
	{
		$symhome = $DEFAULT_SYM_HOME;
	}
	else
	{
		$symhome = $args[0];
	}
	@device_groups = getDeviceGroups($symhome);
        foreach $dev(@device_groups)
        {
                print("$dev\n");
	}
	exit 0;	
}
elsif($ARGV[0] =~ /^-symids/)
{
	my $symhome, $symdg;
	@args = split(/:/, $ARGV[0]);
	shift(@args);
	if($args[0] eq "")
	{
		$symhome = $DEFAULT_SYM_HOME;
	}
	else
	{
		$symhome = $args[0];
	}
	@device_groups = getDeviceGroups($symhome);
        foreach $dev(@device_groups)
        {
		@fields = split(/\s+/, $dev);
                print("$fields[1]\n");
	}
	exit 0;	
}
else
{
	exit 1;
}

sub getDeviceGroups
{
	my ($symhome) = (@_);
	my $symdg = "$symhome/bin/symdg";
	my @dgvect;
	open(SYMDG, "$symdg list |");
	while($line = <SYMDG>)
	{
		chomp($line);
		$line =~ s/^\s+//;
		if($line =~ /RDF/)
		{
			@tok = split(/\s+/, $line);
			$dg = "$tok[0] $tok[3] $symhome";
			push(@dgvect, $dg);
		}
	}
	return @dgvect;
}
